c
c_________________________________________________________________________
c
c*****angfac
c
c     This subroutine calculates the angular dependent factors needed in
c     CURRNT.
c
c     INPUT
c          thetap..................angle of nucleon in final state
c          theta...................angle of nucleon in initial state
c
c     OUTPUT
c          del1(lp,l)..............angular factor 1
c          del2(lp,l)..............angular factor 2
c          del3(lp,l)..............angular factor 3
c
c                   lp=0...........positive helicity
c                     =1...........negative helicity
c                   l=0............positive helicity
c                    =1............negative helicity
c
      subroutine angfac(thetap,theta,del1,del2,del3)
c
      implicit real*8(a-h,o-z)
c
      dimension del1(0:1,0:1),del2(0:1,0:1),del3(0:1,0:1),
     &          dhalfp(0:1,0:1),dhalf(0:1,0:1)
c
      data root2/1.414213562373095/
c
      call rothlf(thetap,dhalfp)
      call rothlf(theta,dhalf)
c
      do 300 l=0,1
        do 200 lp=0,1
          del1(lp,l)=0.0d0
          del2(lp,l)=0.0d0
          do 100 i=0,1
            del1(lp,l)=del1(lp,l)+dhalfp(i,lp)*dhalf(i,l)
            del2(lp,l)=del2(lp,l)+(1.d0-2.d0*i)*dhalfp(i,lp)*dhalf(i,l)
 100      continue
          del3(lp,l)=-root2*dhalfp(0,lp)*dhalf(1,l)
 200    continue
 300  continue
c
      return
      end
