c*****x_section.f
c
c     This subroutine calculates the cross section.
c
      subroutine x_section(E_beam,E_scat,theta_e_deg,theta_l_deg,iff,
     &                     iexch)
c
      implicit real*8 (a-h,o-z)
c
      dimension s_k(6),a_k(9),resp(0:8,0:3,9)
c
      real*8 mn,mt
      common/dpara/mn,mt
c
      parameter(pi=3.141592653589793,alpha_qed=1./137.036d0)
c
  1   format(8(2x,1pe12.5))
  6   format(' Cross section=',1pe12.5,' Mott Cross Section=',1pe12.5,
     &       ' recoil=',1pe12.5)
  7   format(' omega_l=',1pe12.5,' q_l=',1pe12.5,' theta_cm=',1pe12.5,/
     &       ' x=',1pe12.5,' p_l=',1pe12.5,' w=',1pe12.5)
c
      theta_e=pi*theta_e_deg/180.0d0
      theta_l=pi*theta_l_deg/180.0d0
      phi_l=0.0d0
c
      omega_l= E_beam-E_scat
      q2=4.d0*E_beam*E_scat*sin(0.5d0*theta_e)**2
      q=sqrt(q2)
      q_l=sqrt(q2+omega_l**2)
      x=q2/(2.*mn*omega_l)
      w=sqrt(mt**2+2.*mt*omega_l-q2)
	v_l=(q2/q_l**2)**2
	v_t=0.5*q2/q_l**2+tan(theta_e/2)**2
c
c
c                       calculate boost parameters
c
      shztaz=-q_l/w
      chztaz=sqrt(shztaz**2+1.)
c
      p_l=0.5d0*(chztaz*sqrt(w**2-4.*mn**2*
     &        (1.+(shztaz*sin(theta_l))**2))
     &    -w*shztaz*cos(theta_l))/(1.d0+(shztaz*sin(theta_l))**2)
      e_l=sqrt(p_l**2+mn**2)
      p_l_par=p_l*cos(theta_l)
      p_l_perp=p_l*sin(theta_l)
c
      p_cm_par=e_l*shztaz+p_l_par*chztaz
      p_cm_perp=p_l_perp
      p_cm=sqrt(p_cm_par**2+p_cm_perp**2)
      theta_cm=acos(polar_range(p_cm_par/p_cm))
      theta_cm_deg=180.*theta_cm/pi
c
      p_r_l=sqrt(p_l**2+q_l**2-2.*p_l*q_l*cos(theta_l))
c
c      write(6,7) omega_l,q_l,theta_cm_deg,x,p_l,w
c
      sigma_mott=3.894d14*(0.5*alpha_qed*cos(0.5*theta_e)/
     &            (E_beam*sin(0.5*theta_e)**2))**2
c
      recoil=w/(1.+(omega_l*p_l-e_l*q_l*cos(theta_l))/mt/p_l)/mt
      call respns(x,q2,theta_cm,iff,iexch,0,resp)
c
      call k_factors(q_l,q,theta_e,phi_l,s_k,a_k)
c
      cross_section=0.0
c
      do i=1,4
        cross_section= cross_section+s_k(i)*a_k(i)*resp(0,0,i)
      end do
c
      cross_section=sigma_mott*recoil*p_l*q2*cross_section/
     &              (4.*pi*mt*q_l**2)
c
c      write(6,6) cross_section,sigma_mott,recoil
       write(6,1) theta_l_deg,p_r_l,cross_section,sigma_mott,recoil,
     &            W/mt
c       write(6,1) (s_k(k),k=1,4)
c     &            2.*pi**2*q_l**2*resp(0,0,1)/(mn**2*q2),
c     &             2.*pi**2*q_l**2*resp(0,0,2)/(mn**2*q2)
c       write(6,1) theta_l_deg,p_r_l,cross_section,sigma_mott,recoil,
c     &            theta_e_deg,v_l,v_t
c	 write(6,1) s_k(1),s_k(2)
c
      return
      end

       